<?php
/*
Plugin Name: XML Sitemap
Plugin URI: http://xmlsitemap.funsite.cz/
Description: Generates xml sitemap of posts and pages
Author: Martin Fiala
*/



add_action('admin_menu', 'test_plugin_setup_menu');
 
function test_plugin_setup_menu(){
        add_menu_page( 'XML Sitemap Page', 'XML Sitemap', 'manage_options', 'xml-sitemap-plugin', 'test_init' );
}
 
function test_init(){
        //echo "<h1>Hello World!</h1>";
        
if(isset($_POST["gener-sitemap"])) 
  {
     $options = get_option("xsm_plugin_options");
     $links = array();
     if(isset($options["text_string"])) 
        $exclude_slugs = explode(",", $options["text_string"]);
     else $exclude_slugs = array(); 
     
     foreach($exclude_slugs as $ind => $slug)
     {
     	
     	  $exclude_slugs[$ind] = str_replace("/", "", trim($slug));
     }
          
     
     if(isset($options["chkbox_page"])) 
     {     
            
       $args = array(
      'post_type' => 'page',
    /*'tax_query' => array(
        array(
            'taxonomy' => 'genres',
            'field'    => 'slug',
            'terms'    => 'fiction',
        ),
      ),*/
       );
       $query = new WP_Query( $args ); 
     //var_dump($query);       
       if($query->have_posts()) 
       {
     	   while($query->have_posts()) {
     	  	  $query->the_post();
     	  	  $curr_permalink = get_permalink( get_the_ID() );
     	  	  $curr_path = parse_url($curr_permalink)["path"];
     	  	  $curr_path = str_replace("/", "", $curr_path);
           if(!in_array($curr_path, $exclude_slugs) || $curr_path === "" ) $links[] = $curr_permalink;     	  	
     	   }
       } 
     }
     
     
     if(isset($options["chkbox_post"]))
     {
       $args = array(
      'post_type' => 'post',
    /*'tax_query' => array(
        array(
            'taxonomy' => 'genres',
            'field'    => 'slug',
            'terms'    => 'fiction',
        ),
      ),*/
       );
       $query = new WP_Query( $args ); 
       //var_dump($query);       
       if($query->have_posts()) 
       {
     	   while($query->have_posts()) {
     	   	 $query->the_post();
             //$links[] = get_permalink( get_the_ID() );
             $curr_permalink = get_permalink( get_the_ID() );
     	  	    $curr_path = parse_url($curr_permalink)["path"];
     	  	    $curr_path = str_replace("/", "", $curr_path);
             if(!in_array($curr_path, $exclude_slugs) || $curr_path === "" ) $links[] = $curr_permalink;      	  	
     	   }
       }
     }
     //var_dump($links);  
     
     define("_SITEMAP_LINK_CNT_", 50000);
     $outp = '<?xml version="1.0" encoding="UTF-8"?>';
     if(count($links) <= _SITEMAP_LINK_CNT_) 
     {
     	  $outp .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
     	  foreach($links as $link)
     	  {
     	  	  $outp .= "<url><loc>".$link."</loc></url>\n";
     	  }
     	  $outp .= "</urlset>";
     	  $fpc_res = file_put_contents(ABSPATH."sitemap.xml", $outp);
     	  if($fpc_res === false) echo "Error: File sitemap.xml could not be written.<br>";
     	    else echo "File sitemap.xml was succesfully created.<br>";
     	  //echo ABSPATH;
     }else 
     {
     	  $cnt_maps = count($links)/_SITEMAP_LINK_CNT_;
     	  $outp_index = '<?xml version="1.0" encoding="UTF-8"?>';
     	  $outp_index .= '<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
     	  $domain = parse_url($links[0])["scheme"]."://".parse_url($links[0])["host"]."/";
     	  for($ind = 0; $ind < $cnt_maps; $ind++) 
     	  {
     	  	   
           $outp = '<?xml version="1.0" encoding="UTF-8"?>';     	  	  
     	  	  $outp .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
     	  	  for($ind_link = $ind*_SITEMAP_LINK_CNT_ ;  ($ind_link < ($ind + 1)*_SITEMAP_LINK_CNT_) && ($ind_link < count($links)) ; $ind_link++) 
     	  	  {
     	  	  	  $outp .= "<url><loc>".$links[$ind_link]."</loc></url>\n";
     	  	  }
     	  	  $outp .= "</urlset>";
     	  	  $fpc_res = file_put_contents(ABSPATH."sitemap".($ind+1).".xml", $outp);
     	  	  if($fpc_res === false) echo "Error: File sitemap".($ind+1).".xml could not be written.<br>";
     	       else echo "File sitemap".($ind + 1).".xml was succesfully created.<br>";
     	  	  $outp_index .= "<sitemap><loc>".$domain."sitemap".($ind + 1).".xml</loc></sitemap>\n";
     	  }
     	  $outp_index .= "</sitemapindex>";
     	  $fpc_res = file_put_contents(ABSPATH."sitemap_index.xml", $outp_index);
     	  if($fpc_res === false) echo "Error: File sitemap_index.xml could not be written.<br>";
     	    else echo "File sitemap_index.xml was succesfully created.<br>";
     }     
     
   }   //end ifisset gener-sitemap
   
       
        ?>
        <style type="text/css">
        #gener-form{
        	  padding-top:20px;
        }
        </style>
        <h1>XML Sitemap</h1>
        <form id="gener-form" method="post" enctype="multipart/form-data">
        <label>Press this button to generate sitemap: </label>
        <input type="submit" name="gener-sitemap" value="Generate Sitemap">        
        
        </form>
        
        <?php
}

///////////////////////////////////////////////
//SETTINGS begins here
/////////////////////////////////////

// Specify Hooks/Filters
register_activation_hook(__FILE__, 'add_defaults_fn');
add_action('admin_init', 'sampleoptions_init_fn' );
add_action('admin_menu', 'sampleoptions_add_page_fn');

// Define default option settings
function add_defaults_fn() {
	$tmp = get_option('xsm_plugin_options');
    if(($tmp['chkbox1']=='on')||(!is_array($tmp))) {
		$arr = array("dropdown1"=>"Orange", "text_area" => "Space to put a lot of information here!", "text_string" => "", "pass_string" => "123456", "chkbox_page" => "", "chkbox_post" => "", "option_set1" => "Triangle");
		update_option('xsm_plugin_options', $arr);
	}
}

// Register our settings. Add the settings section, and settings fields
function sampleoptions_init_fn(){
	register_setting('xsm_plugin_options', 'xsm_plugin_options', 'xsm_plugin_options_validate' );
	add_settings_section('main_section', 'Include', 'section_text_fn', __FILE__);
	
	//add_settings_field('plugin_text_pass', 'Password Text Input', 'setting_pass_fn', __FILE__, 'main_section');
	//add_settings_field('plugin_textarea_string', 'Large Textbox!', 'setting_textarea_fn', __FILE__, 'main_section');
	add_settings_field('plugin_chk_pages', 'Pages', 'setting_chk_page_fn', __FILE__, 'main_section');
	add_settings_field('plugin_chk_posts', 'Posts', 'setting_chk_post_fn', __FILE__, 'main_section');
	
	add_settings_section('main_section2', 'Exclude', 'section_text_fn2', __FILE__);
	add_settings_field('plugin_text_string', 'Exclude slugs', 'setting_string_fn', __FILE__, 'main_section2');
	//add_settings_field('radio_buttons', 'Select Shape', 'setting_radio_fn', __FILE__, 'main_section');
	//add_settings_field('drop_down1', 'Select Color', 'setting_dropdown_fn', __FILE__, 'main_section');
	//add_settings_field('plugin_chk1', 'Restore Defaults Upon Reactivation?', 'setting_chk1_fn', __FILE__, 'main_section');
}

// Add sub page to the Settings Menu
function sampleoptions_add_page_fn() {
	add_options_page('Options Example Page', 'XML Sitemap settings', 'administrator', __FILE__, 'options_page_fn');
}

// ************************************************************************************************************

// Callback functions

// Section HTML, displayed before the first option
function  section_text_fn() {
	echo '<p>Choose which types to include.</p>';
}


function  section_text_fn2() {
	echo '<p>Specify which slugs to exclude from sitemap. Slugs must be separated by commas in text field.</p>';
}




// TEXTBOX - Name: xsm_plugin_options[text_string]
function setting_string_fn() {
	$options = get_option('xsm_plugin_options');
	echo "<input id='plugin_text_string' name='xsm_plugin_options[text_string]' size='40' type='text' value='{$options['text_string']}' />";
}



// CHECKBOX - Name: xsm_plugin_options[chkbox1]
function setting_chk1_fn() {
	$options = get_option('xsm_plugin_options');
	if($options['chkbox1']) { $checked = ' checked="checked" '; }
	echo "<input ".$checked." id='plugin_chk1' name='xsm_plugin_options[chkbox1]' type='checkbox' />";
}

// CHECKBOX - Name: xsm_plugin_options[chkbox2]
function setting_chk_page_fn() {
	$options = get_option('xsm_plugin_options');
	$checked = "";
	if(isset($options['chkbox_page']) && $options['chkbox_page']) { $checked = ' checked="checked" '; }
	echo "<input ".$checked." id='plugin_chk_page' name='xsm_plugin_options[chkbox_page]' type='checkbox' />";
}


function setting_chk_post_fn() {
	$options = get_option('xsm_plugin_options');
	$checked = "";
	if(isset($options['chkbox_post']) && $options['chkbox_post']) { $checked = ' checked="checked" '; }
	echo "<input ".$checked." id='plugin_chk_post' name='xsm_plugin_options[chkbox_post]' type='checkbox' />";
}


// Display the admin options page
function options_page_fn() {
?>
	<div class="wrap">
		<div class="icon32" id="icon-options-general"><br></div>
		<h2>XML Sitemap settings</h2>
		Choose which type of content will be written to sitemap. 
		<form action="options.php" method="post">
		<?php settings_fields('xsm_plugin_options'); ?>
		<?php do_settings_sections(__FILE__); ?>
		<p class="submit">
			<input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save Changes'); ?>" />
		</p>
		</form>
	</div>
<?php
}

// Validate user data for some/all of your input fields
function xsm_plugin_options_validate($input) {
	// Check our textbox option field contains no HTML tags - if so strip them out
	$input['text_string'] =  wp_filter_nohtml_kses($input['text_string']);	
	return $input; // return validated input
}